function [s1,s2,fs2,Index1,Index2,CorMax] = sync_func(signal1,signal2,fs1,fs2,Tsearch)

% written by Tomonori Nagayama

% signal1 with sampling frequency fs1;
% signal2 with sampling frequency fs2; signal2 is reference with slower
% sampling frequency.
% Tsearch(s) search Tsearch *2 second for timedelay 
% s1, s2 synchronized signals
% fs2 synchronized frequency
% Index1 index for signal1 (start point)
% Index2 index for signal2 (start point and end point)
% CorMax Correlation Coefficient between s1 and s2
%%%%%% Beginning of Function %%%%%%%%%%
% you may need to change FSF
FSF = 1;    % sampling frequency factor. fs = 50.1 --> 10 fs = 50.01 -->100;

CorFun = zeros(Tsearch*fs2*2+1,1);
if fs1< fs2
    fprintf('fs1<fs2');
    return;
end
RefSigInd = Tsearch*fs2+1:length(signal2)-Tsearch*fs2;
RefSig = signal2(RefSigInd);
LenRefSig = length(RefSig);
SyncSig = resample(signal1,round(fs2*FSF),round(fs1*FSF));
x = RefSig;
for cnt1 = 1:Tsearch*fs2*2+1
    y = SyncSig(cnt1:LenRefSig+cnt1-1);
    temp = corrcoef(x,y);
    CorFun(cnt1) = temp(2,1);
end
%figure;plot(CorFun);
[CorMax,Ind1] = max(abs(CorFun));
fprintf('maximum correlation : %f\n at index : %d\n',CorMax, Ind1);
%%%%% End of First Step %%%%%%%%%

%%%%% Second step %%%%%%%%%%%%%%%
%x = RefSig;
SWidth = 2;
CorFun = zeros(ceil(fs1/fs2)*2*SWidth+1,1); 
for cnt1 = 1:ceil(fs1/fs2)*2*SWidth+1
    temp2 = ceil(Ind1*fs1/fs2)-SWidth*ceil(fs1/fs2)+cnt1-1;
    y1 = resample(signal1(temp2:length(signal1)),round(fs2*FSF),round(fs1*FSF));
    y = y1(1:length(x));
    temp = corrcoef(x,y);
    CorFun(cnt1) = temp(2,1);
end

%figure;plot(CorFun);
[CorMax,Ind2] = max(abs(CorFun));
fprintf('maximum correlation : %f\n at index : %d\n',CorMax, Ind2);

temp2 = ceil(Ind1*fs1/fs2)-SWidth*ceil(fs1/fs2)+Ind2-1;
y = resample(signal1(temp2:length(signal1)),round(fs2*FSF),round(fs1*FSF));
y = y(1:length(x));
temp = corrcoef(x,y);
if temp(2,1)<0
    y = -y;
end
CorMax = temp(2,1);
Index1 = temp2;
Index2 = [RefSigInd(1) RefSigInd(length(RefSigInd))];
% t = 1/fs2*(1:length(x));
% y =y*std(x)/std(y);
%figure;plot(t,x,t,y);
s1 = y;
s2 = x;